#include "INTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "libsx.h"

typedef char **String_Array;
typedef short *RGB_Array;

char *		GetWidgetDat();
Widget		Make3Com(), MakeThreeList();
String_Array	XS_unpack_String_Array();
XPoint *	XS_unpack_XPointPtr();

#define MAXARGS 5

struct Edata
{
    Widget w;
    SV *data;
    SV *mysv;
    char *fun[MAXARGS];
    CV *cvcache[MAXARGS];
#define CB_GENFUN 0
#define CB_BU_IDX 1
#define CB_BUTT_1 1
#define CB_BD_IDX 2
#define CB_BUTT_2 2
#define CB_KP_IDX 3
#define CB_BUTT_3 3
#define CB_MM_IDX 4
};

String_Array XS_unpack_String_Array(ax, items)
int ax;
int items;
{
    char **argv;
    int i;
    
    Newz(666, argv, items+1, char *);
    for (i = 0; i < items; i++)
      argv[i] = SvPV(ST(i), na);
    argv[i] = NULL;
    return argv;
}

char *NewString(s)
char *s; {
  char *tmp;

  Newz(666,tmp,strlen(s)+1,char);
  strcpy(tmp,s);
  return tmp;
}

void do_callback(callback, index, sp, extras)
struct Edata *callback;
int sp, extras, index;
{
    register CV *cv;
    GV *gv = Nullgv;
    GV *gvjunk;
    HV *hvjunk;
    BINOP myop;
    
    if (!callback->fun[index] || *(callback->fun[index]) == '\0')
	return;
 
    /* If the CV has not been cached yet, work it out now */
    cv = callback->cvcache[index];
    if (!cv)
    {
      gv = gv_fetchpv(callback->fun[index], FALSE,SVt_PVCV);

      /* If we haven't found anything, give up */
      if (gv == Nullgv)
	croak("method %s not found for callback",callback->fun[index]);

      if (!(cv = sv_2cv(gv, &hvjunk, &gvjunk, FALSE)))
	croak("sv_2cv failed on method");
      callback->cvcache[index] = cv; /* save for future use */
    }
    perl_callsv((SV*)cv, sp, G_SCALAR, extras != 0, extras);
}

void button_callback(Widget w, void *data) 
{
  struct Edata *dd = data;
  int sp = stack_sp - stack_base;

  if (dd->fun[CB_GENFUN] && *(char*)dd->fun[CB_GENFUN]) {
    SvREFCNT_inc(dd->mysv);
    av_store(stack, ++sp, dd->mysv);
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_GENFUN, sp, 2);
  }
}

void but1_callback(Widget w, void *data) 
{
  struct Edata *dd = data;
  int sp = stack_sp - stack_base;

  if (dd->fun[CB_BUTT_1] && *(char*)dd->fun[CB_BUTT_1]) {
    SvREFCNT_inc(dd->mysv);
    av_store(stack, ++sp, dd->mysv);
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_BUTT_1, sp, 2);
  }
}

void but2_callback(Widget w, void *data) 
{
  struct Edata *dd = data;
  int sp = stack_sp - stack_base;

  if (dd->fun[CB_BUTT_2] && *(char*)dd->fun[CB_BUTT_2]) {
    SvREFCNT_inc(dd->mysv);
    av_store(stack, ++sp, dd->mysv);
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_BUTT_2, sp, 2);
  }
}

void but3_callback(Widget w, void *data) 
{
  struct Edata *dd = data;
  int sp = stack_sp - stack_base;

  if (dd->fun[CB_BUTT_3] && *(char*)dd->fun[CB_BUTT_3]) {
    SvREFCNT_inc(dd->mysv);
    av_store(stack, ++sp, dd->mysv);
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_BUTT_3, sp, 2);
  }
}

void string_callback(Widget w, char *string, void *data) 
{
  struct Edata *dd = data;
  int sp = stack_sp - stack_base;

  if (dd->fun[CB_GENFUN] && *(char*)dd->fun[CB_GENFUN]) {
    av_store(stack, ++sp, SvREFCNT_inc(dd->mysv));
    av_store(stack, ++sp, sv_2mortal(newSVpv(string,strlen(string)+1)));
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_GENFUN, sp, 3);
  }
}

void scroll_callback(Widget w, float new_val, void *data) 
{
  struct Edata *dd = data;
  int sp = stack_sp - stack_base;

  if (dd->fun[CB_GENFUN] && *(char*)dd->fun[CB_GENFUN]) {
    av_store(stack, ++sp, SvREFCNT_inc(dd->mysv));
    av_store(stack, ++sp, sv_2mortal(newSVnv((double)new_val)));
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_GENFUN, sp, 3);
  }
}

void list_callback(Widget w, char *string, int index, void *data) 
{
  struct Edata *dd = data;
  int sp = stack_sp - stack_base;

  if (dd->fun[CB_GENFUN] && *(char*)dd->fun[CB_GENFUN]) {
    av_store(stack, ++sp, SvREFCNT_inc(dd->mysv));
    av_store(stack, ++sp, sv_2mortal(newSVpv(string,strlen(string)+1)));
    av_store(stack, ++sp, sv_2mortal(newSViv(index)));
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_GENFUN, sp, 4);
  }
}

void threelist_callback(Widget w, char *string, int index, unsigned int event_mask, void *data) 
{
  struct Edata *dd = data;
  int sp = stack_sp - stack_base;

  if (dd->fun[CB_GENFUN] && *(char*)dd->fun[CB_GENFUN]) {
    av_store(stack, ++sp, SvREFCNT_inc(dd->mysv));
    av_store(stack, ++sp, sv_2mortal(newSVpv(string,strlen(string)+1)));
    av_store(stack, ++sp, sv_2mortal(newSViv(index)));
    av_store(stack, ++sp, sv_2mortal(newSViv(event_mask)));
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_GENFUN, sp, 4);
  }
}

void general_callback(void *data) 
{
  struct Edata *dd = data;
  int sp = stack_sp - stack_base;

  if (dd->fun[CB_GENFUN] && *(char*)dd->fun[CB_GENFUN]) {
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_GENFUN, sp, 1);
  }
}

void io_callback(void *data, int *fd) 
{
  struct Edata *dd = data;
  int sp = stack_sp - stack_base;

  if (dd->fun[CB_GENFUN] && *(char*)dd->fun[CB_GENFUN]) {
    av_store(stack, ++sp, sv_2mortal(newSViv(*fd)));
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_GENFUN, sp, 2);
  }
}

void redisplay_callback(Widget w, int new_width, int new_height, void *data) 
{
  struct Edata *dd = data;
  int sp = stack_sp - stack_base;

  if (dd->fun[CB_GENFUN] && *(char*)dd->fun[CB_GENFUN]) {
    av_store(stack, ++sp, SvREFCNT_inc(dd->mysv));
    av_store(stack, ++sp, sv_2mortal(newSViv(new_width)));
    av_store(stack, ++sp, sv_2mortal(newSViv(new_height)));
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_GENFUN, sp, 4);
  }
}

void button_down_callback(Widget w, int button, int x, int y, void *data) 
{
  struct Edata *dd = data;
    int sp = stack_sp - stack_base;

  if (dd->fun[CB_BU_IDX] && *(char*)dd->fun[CB_BU_IDX]) {
    av_store(stack, ++sp, SvREFCNT_inc(dd->mysv));
    av_store(stack, ++sp, sv_2mortal(newSViv(button)));
    av_store(stack, ++sp, sv_2mortal(newSViv(x)));
    av_store(stack, ++sp, sv_2mortal(newSViv(y)));
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_BD_IDX, sp, 5);
  }
}

void button_up_callback(Widget w, int button, int x, int y, void *data) 
{
  struct Edata *dd = data;
    int sp = stack_sp - stack_base;

  if (dd->fun[CB_BD_IDX] && *(char*)dd->fun[CB_BD_IDX]) {
    av_store(stack, ++sp, SvREFCNT_inc(dd->mysv));
    av_store(stack, ++sp, sv_2mortal(newSViv(button)));
    av_store(stack, ++sp, sv_2mortal(newSViv(x)));
    av_store(stack, ++sp, sv_2mortal(newSViv(y)));
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_BU_IDX, sp, 5);
  }
}

void keypress_callback(Widget w, char *input, int up_or_down, void *data) 
{
  struct Edata *dd = data;
    int sp = stack_sp - stack_base;

  if (dd->fun[CB_KP_IDX] && *(char*)dd->fun[CB_KP_IDX]) {
    av_store(stack, ++sp, SvREFCNT_inc(dd->mysv));
    av_store(stack, ++sp, sv_2mortal(newSVpv(input,strlen(input)+1)));
    av_store(stack, ++sp, sv_2mortal(newSViv(up_or_down)));
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_KP_IDX, sp, 4);
  }
}

void motion_callback(Widget w, int x, int y, void *data) 
{
  struct Edata *dd = data;
    int sp = stack_sp - stack_base;

  if (dd->fun[CB_MM_IDX] && *(char*)dd->fun[CB_MM_IDX]) {
    av_store(stack, ++sp, SvREFCNT_inc(dd->mysv));
    av_store(stack, ++sp, sv_2mortal(newSViv(x)));
    av_store(stack, ++sp, sv_2mortal(newSViv(y)));
    av_store(stack, ++sp, sv_mortalcopy(dd->data));
    do_callback(dd, CB_MM_IDX, sp, 4);
  }
}

struct Edata	*tmp;

XS(XS_Sx_OpenDisplay)
{
    dXSARGS;
    if (items < 1) {
	croak("Usage: Sx::OpenDisplay(args,...)");
    }
    {
	String_Array	args;
	int	RETVAL;
	args = XS_unpack_String_Array(ax+1,items);
	RETVAL = OpenDisplay(items,args);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_ShowDisplay)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::ShowDisplay()");
    }
    {

	ShowDisplay();
    }
    XSRETURN(1);
}

XS(XS_Sx_MainLoop)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::MainLoop()");
    }
    {

	MainLoop();
    }
    XSRETURN(1);
}

XS(XS_Sx_SyncDisplay)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::SyncDisplay()");
    }
    {

	SyncDisplay();
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeWindow)
{
    dXSARGS;
    if (items != 3) {
	croak("Usage: Sx::MakeWindow(window_name, display_name, exclusive)");
    }
    {
	char *	window_name = (char *)SvPV(ST(0),na);
	char *	display_name;
	int	exclusive = (int)SvIV(ST(2));
	Widget	RETVAL;

	Newz(666, tmp , 1, struct Edata);
	display_name = ((ST(2) == Nullsv) ? SAME_DISPLAY : SvPV(ST(2),na));
	RETVAL = MakeWindow(window_name,display_name,exclusive);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_SetCurrentWindow)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::SetCurrentWindow(window)");
    }
    {
	Widget	window;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  window = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          window = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("window (%x) is not a SxWidget",ST(0)); 
	};

	SetCurrentWindow(window);
    }
    XSRETURN(1);
}

XS(XS_Sx_CloseWindow)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::CloseWindow()");
    }
    {

	CloseWindow();
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeForm)
{
    dXSARGS;
    if (items != 5) {
	croak("Usage: Sx::MakeForm(parent, where1, from1, where2, from2)");
    }
    {
	Widget	parent;
	int	where1 = (int)SvIV(ST(1));
	Widget	from1;
	int	where2 = (int)SvIV(ST(3));
	Widget	from2;
	Widget	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  parent = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          parent = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("parent (%x) is not a SxWidget",ST(0)); 
	};

	if ((ST(2) == Nullsv) || (SvTYPE(ST(2)) == SVt_NULL)) {
	  from1 = NULL;
	} else if (sv_isa(ST(2),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(2)));
          from1 = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(2));
	  croak("from1 (%x) is not a SxWidget",ST(2)); 
	};

	if ((ST(4) == Nullsv) || (SvTYPE(ST(4)) == SVt_NULL)) {
	  from2 = NULL;
	} else if (sv_isa(ST(4),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(4)));
          from2 = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(4));
	  croak("from2 (%x) is not a SxWidget",ST(4)); 
	};

	Newz(666, tmp , 1, struct Edata);
	RETVAL = MakeForm(parent, where1, from1, where2, from2);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_SetForm)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::SetForm(form)");
    }
    {
	Widget	form;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  form = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          form = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("form (%x) is not a SxWidget",ST(0)); 
	};

	SetForm(form);
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeButton)
{
    dXSARGS;
    if (items < 2 || items > 3) {
	croak("Usage: Sx::MakeButton(label, callback, data = &sv_undef)");
    }
    {
	char *	label = (char *)SvPV(ST(0),na);
	char *	callback = (char *)SvPV(ST(1),na);
	SV *	data;
	Widget	RETVAL;

	if (items < 3)
	    data = &sv_undef;
	else {
	    data = ST(2);
	}

	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	RETVAL = MakeButton(label, button_callback, tmp);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_Make3Button)
{
    dXSARGS;
    if (items < 4 || items > 5) {
	croak("Usage: Sx::Make3Button(label, callback1, callback2, callback3, data = &sv_undef)");
    }
    {
	char *	label = (char *)SvPV(ST(0),na);
	char *	callback1 = (char *)SvPV(ST(1),na);
	char *	callback2 = (char *)SvPV(ST(2),na);
	char *	callback3 = (char *)SvPV(ST(3),na);
	SV *	data;
	Widget	RETVAL;

	if (items < 5)
	    data = &sv_undef;
	else {
	    data = ST(4);
	}

	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_BUTT_1] = NewString(callback1);
	tmp->fun[CB_BUTT_2] = NewString(callback2);
	tmp->fun[CB_BUTT_3] = NewString(callback3);
	RETVAL = Make3Com(label, but1_callback, but2_callback, but3_callback, tmp);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeLabel)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::MakeLabel(txt)");
    }
    {
	char *	txt = (char *)SvPV(ST(0),na);
	Widget	RETVAL;

	Newz(666, tmp, 1, struct Edata);
	RETVAL = MakeLabel(txt);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeToggle)
{
    dXSARGS;
    if (items < 4 || items > 5) {
	croak("Usage: Sx::MakeToggle(txt, state, widget, callback, data = &sv_undef)");
    }
    {
	char *	txt = (char *)SvPV(ST(0),na);
	int	state = (int)SvIV(ST(1));
	Widget	widget;
	char *	callback = (char *)SvPV(ST(3),na);
	SV *	data;
	Widget	RETVAL;

	if ((ST(2) == Nullsv) || (SvTYPE(ST(2)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(2),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(2)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(2));
	  croak("widget (%x) is not a SxWidget",ST(2)); 
	};

	if (items < 5)
	    data = &sv_undef;
	else {
	    data = ST(4);
	}

	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	RETVAL = MakeToggle(txt, state, widget, button_callback, tmp);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_SetToggleState)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetToggleState(widget, state)");
    }
    {
	Widget	widget;
	int	state = (int)SvIV(ST(1));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetToggleState(widget, state);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetToggleState)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetToggleState(widget)");
    }
    {
	Widget	widget;
	int	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	RETVAL = GetToggleState(widget);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeDrawArea)
{
    dXSARGS;
    if (items < 3 || items > 4) {
	croak("Usage: Sx::MakeDrawArea(width, height, callback, data = &sv_undef)");
    }
    {
	int	width = (int)SvIV(ST(0));
	int	height = (int)SvIV(ST(1));
	char *	callback = (char *)SvPV(ST(2),na);
	SV *	data;
	Widget	RETVAL;

	if (items < 4)
	    data = &sv_undef;
	else {
	    data = ST(3);
	}

	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	RETVAL = MakeDrawArea(width, height, redisplay_callback, tmp);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_SetButtonDownCB)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetButtonDownCB(widget, callback)");
    }
    {
	Widget	widget;
	char *	callback = (char *)SvPV(ST(1),na);
	{
		struct Edata *	w;

		if (sv_isa(ST(1),"SxWidget")) {
			unsigned long tmp;
			tmp = (unsigned long)SvNV((SV*)SvRV(ST(1)));
			w = (struct Edata *) tmp;
		} else
			croak("form is not a SxWidget");
		w->fun[CB_BD_IDX] = callback;
		if (*callback)
			SetButtonDownCB(w->w, button_down_callback);
		else
			SetButtonDownCB(w->w, NULL);
	}
    }
    XSRETURN(1);
}

XS(XS_Sx_SetButtonUpCB)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetButtonUpCB(widget, callback)");
    }
    {
	Widget	widget;
	char *	callback = (char *)SvPV(ST(1),na);
	{
		struct Edata *	w;

		if (sv_isa(ST(1),"SxWidget")) {
			unsigned long tmp;
			tmp = (unsigned long)SvNV((SV*)SvRV(ST(1)));
			w = (struct Edata *) tmp;
		} else
			croak("form is not a SxWidget");
		w->fun[CB_BU_IDX] = callback;
		if (*callback)
			SetButtonUpCB(w->w, button_up_callback);
		else
			SetButtonUpCB(w->w, NULL);
	}
    }
    XSRETURN(1);
}

XS(XS_Sx_SetKeypressCB)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetKeypressCB(widget, callback)");
    }
    {
	Widget	widget;
	char *	callback = (char *)SvPV(ST(1),na);
	{
		struct Edata *	w;

		if (sv_isa(ST(1),"SxWidget")) {
			unsigned long tmp;
			tmp = (unsigned long)SvNV((SV*)SvRV(ST(1)));
			w = (struct Edata *) tmp;
		} else
			croak("form is not a SxWidget");
		w->fun[CB_KP_IDX] = callback;
		if (*callback)
			SetKeypressCB(w->w, keypress_callback);
		else
			SetKeypressCB(w->w, NULL);
	}
    }
    XSRETURN(1);
}

XS(XS_Sx_SetMouseMotionCB)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetMouseMotionCB(widget, callback)");
    }
    {
	Widget	widget;
	char *	callback = (char *)SvPV(ST(1),na);
	{
		struct Edata *	w;

		if (sv_isa(ST(1),"SxWidget")) {
			unsigned long tmp;
			tmp = (unsigned long)SvNV((SV*)SvRV(ST(1)));
			w = (struct Edata *) tmp;
		} else
			croak("form is not a SxWidget");
		w->fun[CB_MM_IDX] = callback;
		if (*callback)
			SetMouseMotionCB(w->w, motion_callback);
		else
			SetMouseMotionCB(w->w, NULL);
	}
    }
    XSRETURN(1);
}

XS(XS_Sx_SetColor)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::SetColor(color)");
    }
    {
	int	color = (int)SvIV(ST(0));

	SetColor(color);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetDrawMode)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::SetDrawMode(mode)");
    }
    {
	int	mode = (int)SvIV(ST(0));

	SetDrawMode(mode);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetLineWidth)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::SetLineWidth(width)");
    }
    {
	int	width = (int)SvIV(ST(0));

	SetLineWidth(width);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetDrawArea)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::SetDrawArea(widget)");
    }
    {
	Widget	widget;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetDrawArea(widget);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetDrawAreaSize)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::GetDrawAreaSize(width, height)");
    }
    {
	int	width;
	int	height;

	GetDrawAreaSize(&width,&height);

	sv_setiv(ST(0), (IV)width);
	sv_setiv(ST(1), (IV)height);
    }
    XSRETURN(1);
}

XS(XS_Sx_ClearDrawArea)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::ClearDrawArea()");
    }
    {

	ClearDrawArea();
    }
    XSRETURN(1);
}

XS(XS_Sx_DrawPixel)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::DrawPixel(x1, y1)");
    }
    {
	int	x1 = (int)SvIV(ST(0));
	int	y1 = (int)SvIV(ST(1));

	DrawPixel(x1, y1);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetPixel)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::GetPixel(x1, y1)");
    }
    {
	int	x1 = (int)SvIV(ST(0));
	int	y1 = (int)SvIV(ST(1));
	int	RETVAL;

	RETVAL = GetPixel(x1, y1);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_DrawLine)
{
    dXSARGS;
    if (items != 4) {
	croak("Usage: Sx::DrawLine(x1, y1, x2, y2)");
    }
    {
	int	x1 = (int)SvIV(ST(0));
	int	y1 = (int)SvIV(ST(1));
	int	x2 = (int)SvIV(ST(2));
	int	y2 = (int)SvIV(ST(3));

	DrawLine(x1, y1, x2, y2);
    }
    XSRETURN(1);
}

XS(XS_Sx_DrawPolyline)
{
    dXSARGS;
    if (items < 1) {
	croak("Usage: Sx::DrawPolyline(points, ...)");
    }
    {
	XPoint *	points;
	{
		int n, i;

		i = items / 2;
		Newz(666,points,i,XPoint);
		for (n = 0; n < i; n++) {
			points[n].x = SvIV(ST(1+(2*n)));
		  	points[n].y = SvIV(ST(2+(2*n)));
		}
		DrawPolyline(points, n);
		Safefree(points);
	}
    }
    XSRETURN(1);
}

XS(XS_Sx_DrawFilledPolygon)
{
    dXSARGS;
    if (items < 1) {
	croak("Usage: Sx::DrawFilledPolygon(points, ...)");
    }
    {
	XPoint *	points;
	{
		int n, i;

		i = items / 2;
		Newz(666,points,i,XPoint);
		for (n = 0; n < i; n++) {
			points[n].x = SvIV(ST(1+(2*n)));
		  	points[n].y = SvIV(ST(2+(2*n)));
		}
		DrawFilledPolygon(points, n);
		Safefree(points);
	}
    }
    XSRETURN(1);
}

XS(XS_Sx_DrawFilledBox)
{
    dXSARGS;
    if (items != 4) {
	croak("Usage: Sx::DrawFilledBox(x, y, width, height)");
    }
    {
	int	x = (int)SvIV(ST(0));
	int	y = (int)SvIV(ST(1));
	int	width = (int)SvIV(ST(2));
	int	height = (int)SvIV(ST(3));

	DrawFilledBox(x, y, width, height);
    }
    XSRETURN(1);
}

XS(XS_Sx_DrawBox)
{
    dXSARGS;
    if (items != 4) {
	croak("Usage: Sx::DrawBox(x, y, width, height)");
    }
    {
	int	x = (int)SvIV(ST(0));
	int	y = (int)SvIV(ST(1));
	int	width = (int)SvIV(ST(2));
	int	height = (int)SvIV(ST(3));

	DrawBox(x, y, width, height);
    }
    XSRETURN(1);
}

XS(XS_Sx_DrawText)
{
    dXSARGS;
    if (items != 3) {
	croak("Usage: Sx::DrawText(string, x, y)");
    }
    {
	char *	string = (char *)SvPV(ST(0),na);
	int	x = (int)SvIV(ST(1));
	int	y = (int)SvIV(ST(2));

	DrawText(string, x, y);
    }
    XSRETURN(1);
}

XS(XS_Sx_DrawArc)
{
    dXSARGS;
    if (items != 6) {
	croak("Usage: Sx::DrawArc(x, y, width, height, angle1, angle2)");
    }
    {
	int	x = (int)SvIV(ST(0));
	int	y = (int)SvIV(ST(1));
	int	width = (int)SvIV(ST(2));
	int	height = (int)SvIV(ST(3));
	double	angle1 = (double)SvNV(ST(4));
	double	angle2 = (double)SvNV(ST(5));

	DrawArc(x, y, width, height, angle1, angle2);
    }
    XSRETURN(1);
}

XS(XS_Sx_DrawFilledArc)
{
    dXSARGS;
    if (items != 6) {
	croak("Usage: Sx::DrawFilledArc(x, y, width, height, angle1, angle2)");
    }
    {
	int	x = (int)SvIV(ST(0));
	int	y = (int)SvIV(ST(1));
	int	width = (int)SvIV(ST(2));
	int	height = (int)SvIV(ST(3));
	double	angle1 = (double)SvNV(ST(4));
	double	angle2 = (double)SvNV(ST(5));

	DrawFilledArc(x, y, width, height, angle1, angle2);
    }
    XSRETURN(1);
}

XS(XS_Sx_DrawImage)
{
    dXSARGS;
    if (items != 5) {
	croak("Usage: Sx::DrawImage(data, x, y, width, height)");
    }
    {
	char *	data = (char *)SvPV(ST(0),na);
	int	x = (int)SvIV(ST(1));
	int	y = (int)SvIV(ST(2));
	int	width = (int)SvIV(ST(3));
	int	height = (int)SvIV(ST(4));

	DrawImage(data, x, y, width, height);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetImage)
{
    dXSARGS;
    if (items != 5) {
	croak("Usage: Sx::GetImage(x, y, width, height, result)");
    }
    {
	int	x = (int)SvIV(ST(0));
	int	y = (int)SvIV(ST(1));
	int	width = (int)SvIV(ST(2));
	int	height = (int)SvIV(ST(3));
	char *	result;
	char *	RETVAL;
	{

		Newz(666,result,width*height,char);
		GetImage(result,x,y,width,height);
	}
	sv_setpv((SV*)ST(4), result);
    }
    XSRETURN(1);
}

XS(XS_Sx_ScrollDrawArea)
{
    dXSARGS;
    if (items != 6) {
	croak("Usage: Sx::ScrollDrawArea(dx, dy, x1, y1, x2, y2)");
    }
    {
	int	dx = (int)SvIV(ST(0));
	int	dy = (int)SvIV(ST(1));
	int	x1 = (int)SvIV(ST(2));
	int	y1 = (int)SvIV(ST(3));
	int	x2 = (int)SvIV(ST(4));
	int	y2 = (int)SvIV(ST(5));

	ScrollDrawArea(dx, dy, x1, y1, x2, y2);
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeStringEntry)
{
    dXSARGS;
    if (items < 3 || items > 4) {
	croak("Usage: Sx::MakeStringEntry(txt, size, callback, data = &sv_undef)");
    }
    {
	char *	txt = (char *)SvPV(ST(0),na);
	int	size = (int)SvIV(ST(1));
	char *	callback = (char *)SvPV(ST(2),na);
	SV *	data;
	Widget	RETVAL;

	if (items < 4)
	    data = &sv_undef;
	else {
	    data = ST(3);
	}

	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	RETVAL = MakeStringEntry(txt, size, string_callback, tmp);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_SetStringEntry)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetStringEntry(widget, new_text)");
    }
    {
	Widget	widget;
	char *	new_text = (char *)SvPV(ST(1),na);

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetStringEntry(widget, new_text);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetStringEntry)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetStringEntry(widget)");
    }
    {
	Widget	widget;
	char *	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	RETVAL = GetStringEntry(widget);
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeTextWidget)
{
    dXSARGS;
    if (items != 5) {
	croak("Usage: Sx::MakeTextWidget(txt, is_file, editable, width, height)");
    }
    {
	char *	txt = (char *)SvPV(ST(0),na);
	int	is_file = (int)SvIV(ST(1));
	int	editable = (int)SvIV(ST(2));
	int	width = (int)SvIV(ST(3));
	int	height = (int)SvIV(ST(4));
	Widget	RETVAL;

	Newz(666, tmp, 1, struct Edata);
	RETVAL = MakeTextWidget(txt, is_file, editable, width, height);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_SetTextWidgetText)
{
    dXSARGS;
    if (items != 3) {
	croak("Usage: Sx::SetTextWidgetText(widget, txt, is_file)");
    }
    {
	Widget	widget;
	char *	txt = (char *)SvPV(ST(1),na);
	int	is_file = (int)SvIV(ST(2));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetTextWidgetText(widget, txt, is_file);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetTextWidgetText)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetTextWidgetText(widget)");
    }
    {
	Widget	widget;
	char *	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	RETVAL = GetTextWidgetText(widget);
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeHorizScrollbar)
{
    dXSARGS;
    if (items < 2 || items > 3) {
	croak("Usage: Sx::MakeHorizScrollbar(len, callback, data = &sv_undef)");
    }
    {
	int	len = (int)SvIV(ST(0));
	char *	callback = (char *)SvPV(ST(1),na);
	SV *	data;
	Widget	RETVAL;

	if (items < 3)
	    data = &sv_undef;
	else {
	    data = ST(2);
	}

	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	RETVAL = MakeHorizScrollbar(len, scroll_callback, tmp);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeVertScrollbar)
{
    dXSARGS;
    if (items < 2 || items > 3) {
	croak("Usage: Sx::MakeVertScrollbar(height, callback, data = &sv_undef)");
    }
    {
	int	height = (int)SvIV(ST(0));
	char *	callback = (char *)SvPV(ST(1),na);
	SV *	data;
	Widget	RETVAL;

	if (items < 3)
	    data = &sv_undef;
	else {
	    data = ST(2);
	}

	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	RETVAL = MakeVertScrollbar(height, scroll_callback, tmp);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_SetScrollbar)
{
    dXSARGS;
    if (items != 4) {
	croak("Usage: Sx::SetScrollbar(widget, where, max, size_shown)");
    }
    {
	Widget	widget;
	int	where = (int)SvIV(ST(1));
	int	max = (int)SvIV(ST(2));
	int	size_shown = (int)SvIV(ST(3));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetScrollbar(widget, where, max, size_shown);
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeScrollList)
{
    dXSARGS;
    if (items < 5) {
	croak("Usage: Sx::MakeScrollList(width, height, callback, data, string, ...)");
    }
    {
	int	width = (int)SvIV(ST(0));
	int	height = (int)SvIV(ST(1));
	char *	callback = (char *)SvPV(ST(2),na);
	SV *	data = ST(3);
	char **	list;
	Widget	RETVAL;

	list = XS_unpack_String_Array(ax+5,items-4);
	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	RETVAL = MakeScrollList(list, width, height, list_callback, tmp);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_Make3List)
{
    dXSARGS;
    if (items < 5) {
	croak("Usage: Sx::Make3List(width, height, callback, data, string, ...)");
    }
    {
	int	width = (int)SvIV(ST(0));
	int	height = (int)SvIV(ST(1));
	char *	callback = (char *)SvPV(ST(2),na);
	SV *	data = ST(3);
	char **	list;
	Widget	RETVAL;

	list = XS_unpack_String_Array(ax+5,items-4);
	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	RETVAL = MakeThreeList(list, width, height, threelist_callback, tmp);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_SetCurrentListItem)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetCurrentListItem(widget, list_index)");
    }
    {
	Widget	widget;
	int	list_index = (int)SvIV(ST(1));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetCurrentListItem(widget, list_index);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetCurrentListItem)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetCurrentListItem(widget)");
    }
    {
	Widget	widget;
	int	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	RETVAL = GetCurrentListItem(widget);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_ChangeScrollList)
{
    dXSARGS;
    if (items < 2) {
	croak("Usage: Sx::ChangeScrollList(widget, new_list, ...)");
    }
    {
	Widget	widget;
	char **	new_list;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};
	new_list = XS_unpack_String_Array(ax+2,items-1);
	ChangeScrollList(widget,new_list);
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeMenu)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::MakeMenu(name)");
    }
    {
	char *	name = (char *)SvPV(ST(0),na);
	Widget	RETVAL;

	Newz(666, tmp, 1, struct Edata);
	RETVAL = MakeMenu(name);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_MakeMenuItem)
{
    dXSARGS;
    if (items < 3 || items > 4) {
	croak("Usage: Sx::MakeMenuItem(menu, name, callback, data = &sv_undef)");
    }
    {
	Widget	menu;
	char *	name = (char *)SvPV(ST(1),na);
	char *	callback = (char *)SvPV(ST(2),na);
	SV *	data;
	Widget	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  menu = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          menu = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("menu (%x) is not a SxWidget",ST(0)); 
	};

	if (items < 4)
	    data = &sv_undef;
	else {
	    data = ST(3);
	}

	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	RETVAL = MakeMenuItem(menu, name, button_callback, tmp);

	ST(0) = sv_newmortal();
	tmp->w = RETVAL;
	tmp->mysv = ST(0);
	sv_setptrobj(tmp->mysv, tmp, "SxWidget");
	SvREFCNT_inc(tmp->mysv);	
	ST(0) = tmp->mysv;
    }
    XSRETURN(1);
}

XS(XS_Sx_SetMenuItemChecked)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetMenuItemChecked(widget, state)");
    }
    {
	Widget	widget;
	int	state = (int)SvIV(ST(1));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetMenuItemChecked(widget, state);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetMenuItemChecked)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetMenuItemChecked(widget)");
    }
    {
	Widget	widget;
	int	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	RETVAL = GetMenuItemChecked(widget);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetWidgetPos)
{
    dXSARGS;
    if (items != 5) {
	croak("Usage: Sx::SetWidgetPos(parent, where1, from1, where2, from2)");
    }
    {
	Widget	parent;
	int	where1 = (int)SvIV(ST(1));
	Widget	from1;
	int	where2 = (int)SvIV(ST(3));
	Widget	from2;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  parent = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          parent = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("parent (%x) is not a SxWidget",ST(0)); 
	};

	if ((ST(2) == Nullsv) || (SvTYPE(ST(2)) == SVt_NULL)) {
	  from1 = NULL;
	} else if (sv_isa(ST(2),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(2)));
          from1 = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(2));
	  croak("from1 (%x) is not a SxWidget",ST(2)); 
	};

	if ((ST(4) == Nullsv) || (SvTYPE(ST(4)) == SVt_NULL)) {
	  from2 = NULL;
	} else if (sv_isa(ST(4),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(4)));
          from2 = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(4));
	  croak("from2 (%x) is not a SxWidget",ST(4)); 
	};

	SetWidgetPos(parent, where1, from1, where2, from2);
    }
    XSRETURN(1);
}

XS(XS_Sx_AttachEdge)
{
    dXSARGS;
    if (items != 3) {
	croak("Usage: Sx::AttachEdge(widget, edge, attach_to)");
    }
    {
	Widget	widget;
	int	edge = (int)SvIV(ST(1));
	int	attach_to = (int)SvIV(ST(2));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	AttachEdge(widget, edge, attach_to);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetFgColor)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetFgColor(widget, color)");
    }
    {
	Widget	widget;
	int	color = (int)SvIV(ST(1));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetFgColor(widget, color);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetBgColor)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetBgColor(widget, color)");
    }
    {
	Widget	widget;
	int	color = (int)SvIV(ST(1));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetBgColor(widget, color);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetBorderColor)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetBorderColor(widget, color)");
    }
    {
	Widget	widget;
	int	color = (int)SvIV(ST(1));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetBorderColor(widget, color);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetFgColor)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetFgColor(widget)");
    }
    {
	Widget	widget;
	int	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	RETVAL = GetFgColor(widget);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetBgColor)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetBgColor(widget)");
    }
    {
	Widget	widget;
	int	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	RETVAL = GetBgColor(widget);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetLabel)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetLabel(widget, txt)");
    }
    {
	Widget	widget;
	char *	txt = (char *)SvPV(ST(1),na);

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetLabel(widget, txt);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetWidgetState)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetWidgetState(widget, state)");
    }
    {
	Widget	widget;
	int	state = (int)SvIV(ST(1));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetWidgetState(widget, state);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetWidgetState)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetWidgetState(widget)");
    }
    {
	Widget	widget;
	int	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	RETVAL = GetWidgetState(widget);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetWidgetBitmap)
{
    dXSARGS;
    if (items != 4) {
	croak("Usage: Sx::SetWidgetBitmap(widget, data, width, height)");
    }
    {
	Widget	widget;
	char *	data = (char *)SvPV(ST(1),na);
	int	width = (int)SvIV(ST(2));
	int	height = (int)SvIV(ST(3));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetWidgetBitmap(widget, data, width, height);
    }
    XSRETURN(1);
}

XS(XS_Sx_Beep)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::Beep()");
    }
    {

	Beep();
    }
    XSRETURN(1);
}

XS(XS_Sx_GetFont)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetFont(fontname)");
    }
    {
	char *	fontname = (char *)SvPV(ST(0),na);
	XFont	RETVAL;

	RETVAL = GetFont(fontname);
	ST(0) = sv_newmortal();
	sv_setref_iv(ST(0), "XFont", (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetWidgetFont)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::SetWidgetFont(widget, font)");
    }
    {
	Widget	widget;
	XFont	font;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	if (sv_isa(ST(1), "XFont")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    font = (XFont) tmp;
	}
	else
	    croak("font is not of type XFont");

	SetWidgetFont(widget, font);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetWidgetFont)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetWidgetFont(widget)");
    }
    {
	Widget	widget;
	XFont	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	RETVAL = GetWidgetFont(widget);
	ST(0) = sv_newmortal();
	sv_setref_iv(ST(0), "XFont", (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_FreeFont)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::FreeFont(font)");
    }
    {
	XFont	font;

	if (sv_isa(ST(0), "XFont")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    font = (XFont) tmp;
	}
	else
	    croak("font is not of type XFont");

	FreeFont(font);
    }
    XSRETURN(1);
}

XS(XS_Sx_FontHeight)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::FontHeight(font)");
    }
    {
	XFont	font;
	int	RETVAL;

	if (sv_isa(ST(0), "XFont")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    font = (XFont) tmp;
	}
	else
	    croak("font is not of type XFont");

	RETVAL = FontHeight(font);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_TextWidth)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::TextWidth(font, txt)");
    }
    {
	XFont	font;
	char *	txt = (char *)SvPV(ST(1),na);
	int	RETVAL;

	if (sv_isa(ST(0), "XFont")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    font = (XFont) tmp;
	}
	else
	    croak("font is not of type XFont");

	RETVAL = TextWidth(font, txt);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_AddTimeOut)
{
    dXSARGS;
    if (items < 2 || items > 3) {
	croak("Usage: Sx::AddTimeOut(interval, callback, data = &sv_undef)");
    }
    {
	unsigned long	interval = (unsigned long)SvIV(ST(0));
	char *	callback = (char *)SvPV(ST(1),na);
	SV *	data;

	if (items < 3)
	    data = &sv_undef;
	else {
	    data = ST(2);
	}
	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	AddTimeOut(interval, general_callback, tmp);
    }
    XSRETURN(1);
}

XS(XS_Sx_AddReadCallback)
{
    dXSARGS;
    if (items < 2 || items > 3) {
	croak("Usage: Sx::AddReadCallback(fd, callback, data = &sv_undef)");
    }
    {
	int	fd = (int)SvIV(ST(0));
	char *	callback = (char *)SvPV(ST(1),na);
	SV *	data;

	if (items < 3)
	    data = &sv_undef;
	else {
	    data = ST(2);
	}
	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	AddReadCallback(fd, io_callback, tmp);
    }
    XSRETURN(1);
}

XS(XS_Sx_AddWriteCallback)
{
    dXSARGS;
    if (items < 2 || items > 3) {
	croak("Usage: Sx::AddWriteCallback(fd, callback, data = &sv_undef)");
    }
    {
	int	fd = (int)SvIV(ST(0));
	char *	callback = (char *)SvPV(ST(1),na);
	SV *	data;

	if (items < 3)
	    data = &sv_undef;
	else {
	    data = ST(2);
	}
	Newz(666, tmp, 1, struct Edata);
	tmp->data = newSVsv(data);
	tmp->fun[CB_GENFUN] = NewString(callback);
	AddWriteCallback(fd, io_callback, tmp);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetString)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::GetString(blurb, default_string)");
    }
    {
	char *	blurb = (char *)SvPV(ST(0),na);
	char *	default_string = (char *)SvPV(ST(1),na);
	char *	RETVAL;

	RETVAL = GetString(blurb, default_string);
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetYesNo)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetYesNo(question)");
    }
    {
	char *	question = (char *)SvPV(ST(0),na);
	int	RETVAL;

	RETVAL = GetYesNo(question);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetStandardColors)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::GetStandardColors()");
    }
    {

	GetStandardColors();
    }
    XSRETURN(1);
}

XS(XS_Sx_GetNamedColor)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::GetNamedColor(name)");
    }
    {
	char *	name = (char *)SvPV(ST(0),na);
	int	RETVAL;

	RETVAL = GetNamedColor(name);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetRGBColor)
{
    dXSARGS;
    if (items != 3) {
	croak("Usage: Sx::GetRGBColor(red, green, blue)");
    }
    {
	int	red = (int)SvIV(ST(0));
	int	green = (int)SvIV(ST(1));
	int	blue = (int)SvIV(ST(2));
	int	RETVAL;

	RETVAL = GetRGBColor(red, green, blue);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_FreeStandardColors)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::FreeStandardColors()");
    }
    {

	FreeStandardColors();
    }
    XSRETURN(1);
}

XS(XS_Sx_GetPrivateColor)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::GetPrivateColor()");
    }
    {
	int	RETVAL;

	RETVAL = GetPrivateColor();
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetPrivateColor)
{
    dXSARGS;
    if (items != 4) {
	croak("Usage: Sx::SetPrivateColor(which, red, green, blue)");
    }
    {
	int	which = (int)SvIV(ST(0));
	int	red = (int)SvIV(ST(1));
	int	green = (int)SvIV(ST(2));
	int	blue = (int)SvIV(ST(3));

	SetPrivateColor(which, red, green, blue);
    }
    XSRETURN(1);
}

XS(XS_Sx_FreePrivateColor)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::FreePrivateColor(which)");
    }
    {
	int	which = (int)SvIV(ST(0));

	FreePrivateColor(which);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetAllColors)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::GetAllColors()");
    }
    {
	int	RETVAL;

	RETVAL = GetAllColors();
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetColorMap)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::SetColorMap(num)");
    }
    {
	int	num = (int)SvIV(ST(0));

	SetColorMap(num);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetMyColorMap)
{
    dXSARGS;
    if (items < 1) {
	croak("Usage: Sx::SetMyColorMap(color_array, ...)");
    }
    {
	RGB_Array	color_array;
	{
		unsigned char *red, *green, *blue;
		int n, i;
		
		i = items / 3;
		Newz(666,red,i,unsigned char);
		Newz(666,green,i,unsigned char);
		Newz(666,blue,i,unsigned char);
		for (n = 0; n < i; n++) {
			red[n] = (unsigned char) 	SvIV(ST(1+(n*3)));
			green[n] = (unsigned char)	SvIV(ST(2+(n*3)));
			blue[n] = (unsigned char)	SvIV(ST(3+(n*3)));
		}
		SetMyColorMap(i,red,green,blue);
		Safefree(red); Safefree(green); Safefree(blue); 
	}		
    }
    XSRETURN(1);
}

XS(XS_Sx_FreeAllColors)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::FreeAllColors()");
    }
    {

	FreeAllColors();
    }
    XSRETURN(1);
}

XS(XS_Sx_XtDestroyWidget)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::XtDestroyWidget(widget)");
    }
    {
	Widget	widget;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	XtDestroyWidget(widget);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetWidgetInt)
{
    dXSARGS;
    if (items != 3) {
	croak("Usage: Sx::SetWidgetInt(widget, resource, value)");
    }
    {
	Widget	widget;
	char *	resource = (char *)SvPV(ST(1),na);
	int	value = (int)SvIV(ST(2));

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetWidgetInt(widget, resource, value);
    }
    XSRETURN(1);
}

XS(XS_Sx_SetWidgetDat)
{
    dXSARGS;
    if (items != 3) {
	croak("Usage: Sx::SetWidgetDat(widget, resource, value)");
    }
    {
	Widget	widget;
	char *	resource = (char *)SvPV(ST(1),na);
	char *	value = (char *)SvPV(ST(2),na);

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	SetWidgetDat(widget, resource, value);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetWidgetInt)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::GetWidgetInt(widget, resource)");
    }
    {
	Widget	widget;
	char *	resource = (char *)SvPV(ST(1),na);
	int	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	RETVAL = GetWidgetInt(widget, resource);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_GetWidgetDat)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::GetWidgetDat(widget, resource)");
    }
    {
	Widget	widget;
	char *	resource = (char *)SvPV(ST(1),na);
	char *	RETVAL;

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	RETVAL = GetWidgetDat(widget, resource);
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_AppendText)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::AppendText(widget, text)");
    }
    {
	Widget	widget;
	char *	text = (char *)SvPV(ST(1),na);

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	AppendText(widget, text);
    }
    XSRETURN(1);
}

XS(XS_Sx_InsertText)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Sx::InsertText(widget, text)");
    }
    {
	Widget	widget;
	char *	text = (char *)SvPV(ST(1),na);

	if ((ST(0) == Nullsv) || (SvTYPE(ST(0)) == SVt_NULL)) {
	  widget = NULL;
	} else if (sv_isa(ST(0),"SxWidget")) {
	  unsigned long tmp;
	  tmp = (unsigned long)SvNV((SV*)SvRV(ST(0)));
          widget = ((struct Edata *)(tmp))->w;
	} else {
	  sv_dump(ST(0));
	  croak("widget (%x) is not a SxWidget",ST(0)); 
	};

	InsertText(widget, text);
    }
    XSRETURN(1);
}

XS(XS_Sx_DebugOn)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::DebugOn(flags)");
    }
    {
	char *	flags = (char *)SvPV(ST(0),na);
		if (isALPHA(*flags)) {
		  static char debopts[] = "psltocPmfrxuLHXD";
		  char *d;
		
		  for (flags; *flags && (d = strchr(debopts,*flags)); flags++)
		    debug |= 1 << (d - debopts);
		}
		else {
		  debug |= atoi(flags+1);
		}
		debug |= 0x80000000;
    }
    XSRETURN(1);
}

XS(XS_Sx_DebugOff)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Sx::DebugOff(flags)");
    }
    {
	char *	flags = (char *)SvPV(ST(0),na);
		if (isALPHA(*flags)) {
		  static char debopts[] = "psltocPmfrxuLHXD";
		  char *d;
		
		  for (flags; *flags && (d = strchr(debopts,*flags)); flags++)
		    debug &= ~(1 << (d - debopts));
		}
		else {
		  debug &= ~(atoi(flags+1));
		}
		if (debug == 0x80000000)
		  debug = 0;
    }
    XSRETURN(1);
}

XS(XS_Sx_WHITE)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::WHITE()");
    }
    {
	int	RETVAL;
	RETVAL = WHITE;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_BLACK)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::BLACK()");
    }
    {
	int	RETVAL;
	RETVAL = BLACK;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_RED)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::RED()");
    }
    {
	int	RETVAL;
	RETVAL = RED;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_GREEN)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::GREEN()");
    }
    {
	int	RETVAL;
	RETVAL = GREEN;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_BLUE)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::BLUE()");
    }
    {
	int	RETVAL;
	RETVAL = BLUE;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_YELLOW)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::YELLOW()");
    }
    {
	int	RETVAL;
	RETVAL = YELLOW;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_SAME_DISPLAY)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::SAME_DISPLAY()");
    }
    {
	SV *	RETVAL;
	RETVAL = Nullsv;
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Sx_NONEXCLUSIVE_WINDOW)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::NONEXCLUSIVE_WINDOW()");
    }
    {
	int	RETVAL;
	RETVAL = NONEXCLUSIVE_WINDOW;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_EXCLUSIVE_WINDOW)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::EXCLUSIVE_WINDOW()");
    }
    {
	int	RETVAL;
	RETVAL = EXCLUSIVE_WINDOW;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_ORIGINAL_WINDOW)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::ORIGINAL_WINDOW()");
    }
    {
	SV *	RETVAL;
	RETVAL = Nullsv;
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Sx_TOP_LEVEL_FORM)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::TOP_LEVEL_FORM()");
    }
    {
	SV *	RETVAL;
	RETVAL = Nullsv;
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Sx_SANE_XOR)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::SANE_XOR()");
    }
    {
	int	RETVAL;
	RETVAL = SANE_XOR;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_NO_CARE)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::NO_CARE()");
    }
    {
	int	RETVAL;
	RETVAL = NO_CARE;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_NullSx)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::NullSx()");
    }
    {
	SV *	RETVAL;
	RETVAL = Nullsv;
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Sx_PLACE_RIGHT)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::PLACE_RIGHT()");
    }
    {
	int	RETVAL;
	RETVAL = PLACE_RIGHT;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_PLACE_UNDER)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::PLACE_UNDER()");
    }
    {
	int	RETVAL;
	RETVAL = PLACE_UNDER;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_LEFT_EDGE)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::LEFT_EDGE()");
    }
    {
	int	RETVAL;
	RETVAL = LEFT_EDGE;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_RIGHT_EDGE)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::RIGHT_EDGE()");
    }
    {
	int	RETVAL;
	RETVAL = RIGHT_EDGE;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_TOP_EDGE)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::TOP_EDGE()");
    }
    {
	int	RETVAL;
	RETVAL = TOP_EDGE;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_BOTTOM_EDGE)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::BOTTOM_EDGE()");
    }
    {
	int	RETVAL;
	RETVAL = BOTTOM_EDGE;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_ATTACH_LEFT)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::ATTACH_LEFT()");
    }
    {
	int	RETVAL;
	RETVAL = ATTACH_LEFT;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_ATTACH_RIGHT)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::ATTACH_RIGHT()");
    }
    {
	int	RETVAL;
	RETVAL = ATTACH_RIGHT;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_ATTACH_TOP)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::ATTACH_TOP()");
    }
    {
	int	RETVAL;
	RETVAL = ATTACH_TOP;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_ATTACH_BOTTOM)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::ATTACH_BOTTOM()");
    }
    {
	int	RETVAL;
	RETVAL = ATTACH_BOTTOM;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_GREY_SCALE_1)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::GREY_SCALE_1()");
    }
    {
	int	RETVAL;
	RETVAL = GREY_SCALE_1;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_GREY_SCALE_2)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::GREY_SCALE_2()");
    }
    {
	int	RETVAL;
	RETVAL = GREY_SCALE_2;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_RAINBOW_1)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::RAINBOW_1()");
    }
    {
	int	RETVAL;
	RETVAL = RAINBOW_1;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Sx_RAINBOW_2)
{
    dXSARGS;
    if (items != 0) {
	croak("Usage: Sx::RAINBOW_2()");
    }
    {
	int	RETVAL;
	RETVAL = RAINBOW_2;
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(boot_Sx)
{
    dXSARGS;
    char* file = __FILE__;

    newXS("Sx::OpenDisplay", XS_Sx_OpenDisplay, file);
    newXS("Sx::ShowDisplay", XS_Sx_ShowDisplay, file);
    newXS("Sx::MainLoop", XS_Sx_MainLoop, file);
    newXS("Sx::SyncDisplay", XS_Sx_SyncDisplay, file);
    newXS("Sx::MakeWindow", XS_Sx_MakeWindow, file);
    newXS("Sx::SetCurrentWindow", XS_Sx_SetCurrentWindow, file);
    newXS("Sx::CloseWindow", XS_Sx_CloseWindow, file);
    newXS("Sx::MakeForm", XS_Sx_MakeForm, file);
    newXS("Sx::SetForm", XS_Sx_SetForm, file);
    newXS("Sx::MakeButton", XS_Sx_MakeButton, file);
    newXS("Sx::Make3Button", XS_Sx_Make3Button, file);
    newXS("Sx::MakeLabel", XS_Sx_MakeLabel, file);
    newXS("Sx::MakeToggle", XS_Sx_MakeToggle, file);
    newXS("Sx::SetToggleState", XS_Sx_SetToggleState, file);
    newXS("Sx::GetToggleState", XS_Sx_GetToggleState, file);
    newXS("Sx::MakeDrawArea", XS_Sx_MakeDrawArea, file);
    newXS("Sx::SetButtonDownCB", XS_Sx_SetButtonDownCB, file);
    newXS("Sx::SetButtonUpCB", XS_Sx_SetButtonUpCB, file);
    newXS("Sx::SetKeypressCB", XS_Sx_SetKeypressCB, file);
    newXS("Sx::SetMouseMotionCB", XS_Sx_SetMouseMotionCB, file);
    newXS("Sx::SetColor", XS_Sx_SetColor, file);
    newXS("Sx::SetDrawMode", XS_Sx_SetDrawMode, file);
    newXS("Sx::SetLineWidth", XS_Sx_SetLineWidth, file);
    newXS("Sx::SetDrawArea", XS_Sx_SetDrawArea, file);
    newXS("Sx::GetDrawAreaSize", XS_Sx_GetDrawAreaSize, file);
    newXS("Sx::ClearDrawArea", XS_Sx_ClearDrawArea, file);
    newXS("Sx::DrawPixel", XS_Sx_DrawPixel, file);
    newXS("Sx::GetPixel", XS_Sx_GetPixel, file);
    newXS("Sx::DrawLine", XS_Sx_DrawLine, file);
    newXS("Sx::DrawPolyline", XS_Sx_DrawPolyline, file);
    newXS("Sx::DrawFilledPolygon", XS_Sx_DrawFilledPolygon, file);
    newXS("Sx::DrawFilledBox", XS_Sx_DrawFilledBox, file);
    newXS("Sx::DrawBox", XS_Sx_DrawBox, file);
    newXS("Sx::DrawText", XS_Sx_DrawText, file);
    newXS("Sx::DrawArc", XS_Sx_DrawArc, file);
    newXS("Sx::DrawFilledArc", XS_Sx_DrawFilledArc, file);
    newXS("Sx::DrawImage", XS_Sx_DrawImage, file);
    newXS("Sx::GetImage", XS_Sx_GetImage, file);
    newXS("Sx::ScrollDrawArea", XS_Sx_ScrollDrawArea, file);
    newXS("Sx::MakeStringEntry", XS_Sx_MakeStringEntry, file);
    newXS("Sx::SetStringEntry", XS_Sx_SetStringEntry, file);
    newXS("Sx::GetStringEntry", XS_Sx_GetStringEntry, file);
    newXS("Sx::MakeTextWidget", XS_Sx_MakeTextWidget, file);
    newXS("Sx::SetTextWidgetText", XS_Sx_SetTextWidgetText, file);
    newXS("Sx::GetTextWidgetText", XS_Sx_GetTextWidgetText, file);
    newXS("Sx::MakeHorizScrollbar", XS_Sx_MakeHorizScrollbar, file);
    newXS("Sx::MakeVertScrollbar", XS_Sx_MakeVertScrollbar, file);
    newXS("Sx::SetScrollbar", XS_Sx_SetScrollbar, file);
    newXS("Sx::MakeScrollList", XS_Sx_MakeScrollList, file);
    newXS("Sx::Make3List", XS_Sx_Make3List, file);
    newXS("Sx::SetCurrentListItem", XS_Sx_SetCurrentListItem, file);
    newXS("Sx::GetCurrentListItem", XS_Sx_GetCurrentListItem, file);
    newXS("Sx::ChangeScrollList", XS_Sx_ChangeScrollList, file);
    newXS("Sx::MakeMenu", XS_Sx_MakeMenu, file);
    newXS("Sx::MakeMenuItem", XS_Sx_MakeMenuItem, file);
    newXS("Sx::SetMenuItemChecked", XS_Sx_SetMenuItemChecked, file);
    newXS("Sx::GetMenuItemChecked", XS_Sx_GetMenuItemChecked, file);
    newXS("Sx::SetWidgetPos", XS_Sx_SetWidgetPos, file);
    newXS("Sx::AttachEdge", XS_Sx_AttachEdge, file);
    newXS("Sx::SetFgColor", XS_Sx_SetFgColor, file);
    newXS("Sx::SetBgColor", XS_Sx_SetBgColor, file);
    newXS("Sx::SetBorderColor", XS_Sx_SetBorderColor, file);
    newXS("Sx::GetFgColor", XS_Sx_GetFgColor, file);
    newXS("Sx::GetBgColor", XS_Sx_GetBgColor, file);
    newXS("Sx::SetLabel", XS_Sx_SetLabel, file);
    newXS("Sx::SetWidgetState", XS_Sx_SetWidgetState, file);
    newXS("Sx::GetWidgetState", XS_Sx_GetWidgetState, file);
    newXS("Sx::SetWidgetBitmap", XS_Sx_SetWidgetBitmap, file);
    newXS("Sx::Beep", XS_Sx_Beep, file);
    newXS("Sx::GetFont", XS_Sx_GetFont, file);
    newXS("Sx::SetWidgetFont", XS_Sx_SetWidgetFont, file);
    newXS("Sx::GetWidgetFont", XS_Sx_GetWidgetFont, file);
    newXS("Sx::FreeFont", XS_Sx_FreeFont, file);
    newXS("Sx::FontHeight", XS_Sx_FontHeight, file);
    newXS("Sx::TextWidth", XS_Sx_TextWidth, file);
    newXS("Sx::AddTimeOut", XS_Sx_AddTimeOut, file);
    newXS("Sx::AddReadCallback", XS_Sx_AddReadCallback, file);
    newXS("Sx::AddWriteCallback", XS_Sx_AddWriteCallback, file);
    newXS("Sx::GetString", XS_Sx_GetString, file);
    newXS("Sx::GetYesNo", XS_Sx_GetYesNo, file);
    newXS("Sx::GetStandardColors", XS_Sx_GetStandardColors, file);
    newXS("Sx::GetNamedColor", XS_Sx_GetNamedColor, file);
    newXS("Sx::GetRGBColor", XS_Sx_GetRGBColor, file);
    newXS("Sx::FreeStandardColors", XS_Sx_FreeStandardColors, file);
    newXS("Sx::GetPrivateColor", XS_Sx_GetPrivateColor, file);
    newXS("Sx::SetPrivateColor", XS_Sx_SetPrivateColor, file);
    newXS("Sx::FreePrivateColor", XS_Sx_FreePrivateColor, file);
    newXS("Sx::GetAllColors", XS_Sx_GetAllColors, file);
    newXS("Sx::SetColorMap", XS_Sx_SetColorMap, file);
    newXS("Sx::SetMyColorMap", XS_Sx_SetMyColorMap, file);
    newXS("Sx::FreeAllColors", XS_Sx_FreeAllColors, file);
    newXS("Sx::XtDestroyWidget", XS_Sx_XtDestroyWidget, file);
    newXS("Sx::SetWidgetInt", XS_Sx_SetWidgetInt, file);
    newXS("Sx::SetWidgetDat", XS_Sx_SetWidgetDat, file);
    newXS("Sx::GetWidgetInt", XS_Sx_GetWidgetInt, file);
    newXS("Sx::GetWidgetDat", XS_Sx_GetWidgetDat, file);
    newXS("Sx::AppendText", XS_Sx_AppendText, file);
    newXS("Sx::InsertText", XS_Sx_InsertText, file);
    newXS("Sx::DebugOn", XS_Sx_DebugOn, file);
    newXS("Sx::DebugOff", XS_Sx_DebugOff, file);
    newXS("Sx::WHITE", XS_Sx_WHITE, file);
    newXS("Sx::BLACK", XS_Sx_BLACK, file);
    newXS("Sx::RED", XS_Sx_RED, file);
    newXS("Sx::GREEN", XS_Sx_GREEN, file);
    newXS("Sx::BLUE", XS_Sx_BLUE, file);
    newXS("Sx::YELLOW", XS_Sx_YELLOW, file);
    newXS("Sx::SAME_DISPLAY", XS_Sx_SAME_DISPLAY, file);
    newXS("Sx::NONEXCLUSIVE_WINDOW", XS_Sx_NONEXCLUSIVE_WINDOW, file);
    newXS("Sx::EXCLUSIVE_WINDOW", XS_Sx_EXCLUSIVE_WINDOW, file);
    newXS("Sx::ORIGINAL_WINDOW", XS_Sx_ORIGINAL_WINDOW, file);
    newXS("Sx::TOP_LEVEL_FORM", XS_Sx_TOP_LEVEL_FORM, file);
    newXS("Sx::SANE_XOR", XS_Sx_SANE_XOR, file);
    newXS("Sx::NO_CARE", XS_Sx_NO_CARE, file);
    newXS("Sx::NullSx", XS_Sx_NullSx, file);
    newXS("Sx::PLACE_RIGHT", XS_Sx_PLACE_RIGHT, file);
    newXS("Sx::PLACE_UNDER", XS_Sx_PLACE_UNDER, file);
    newXS("Sx::LEFT_EDGE", XS_Sx_LEFT_EDGE, file);
    newXS("Sx::RIGHT_EDGE", XS_Sx_RIGHT_EDGE, file);
    newXS("Sx::TOP_EDGE", XS_Sx_TOP_EDGE, file);
    newXS("Sx::BOTTOM_EDGE", XS_Sx_BOTTOM_EDGE, file);
    newXS("Sx::ATTACH_LEFT", XS_Sx_ATTACH_LEFT, file);
    newXS("Sx::ATTACH_RIGHT", XS_Sx_ATTACH_RIGHT, file);
    newXS("Sx::ATTACH_TOP", XS_Sx_ATTACH_TOP, file);
    newXS("Sx::ATTACH_BOTTOM", XS_Sx_ATTACH_BOTTOM, file);
    newXS("Sx::GREY_SCALE_1", XS_Sx_GREY_SCALE_1, file);
    newXS("Sx::GREY_SCALE_2", XS_Sx_GREY_SCALE_2, file);
    newXS("Sx::RAINBOW_1", XS_Sx_RAINBOW_1, file);
    newXS("Sx::RAINBOW_2", XS_Sx_RAINBOW_2, file);
    ST(0) = &sv_yes;
    XSRETURN(1);
}
